<?php
############################################################################
# A Project of TNET Services, Inc. and Saratoga-Weather.org (WD-World-ML template set)
############################################################################
#
#	Project:	Sample Included Website Design
#	Module:		Settings-weather.php
#	Purpose:	Provides the Site Settings Used Throughout the Site
# 	Authors:	Kevin W. Reed <kreed@tnet.com>
#				TNET Services, Inc.
#               Ken True <webmaster@saratoga-weather.org>
#               Saratoga-Weather.org
#
# 	Copyright:	(c) 1992-2007 Copyright TNET Services, Inc.
############################################################################
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
############################################################################
#	This document uses Tab 4 Settings
############################################################################
# Version 1.01 - 31-Mar-2012 - added $SITE['overrideRain'] to settings
global $SITE;
#---------------------------------------------------------------------------
#  required settings for WeatherLink (WL) software
#---------------------------------------------------------------------------
$SITE['WXsoftwareVersion'] = '5.8.3';  // Your WeatherLink software version
$SITE['WXtags']		   = 'WLtags.php';  // for weather variables
# --------------------------------------------------------------------------
# Optional realtime settings.  Use if you are using 1 minute uploads of the WLrealtime.txt file
# uncomment next two lines (ajaxScript, WLrealtime) to enable AJAX updates to your website. 
# $SITE['ajaxScript']        = 'ajaxWLwx.js'; // for AJAX enabled display
# $SITE['WLrealtime']        = 'WLrealtime.txt';  // directory and name of WeatherLink WLrealtime.txt file
# --------------------------------------------------------------------------
# 
$SITE['graphImageDir']     = './';  // directory location for graph images with trailing /
$SITE['NOAAdir']           = './NOAA-reports/';   // relative location of the stored NOAA report files directory
$SITE['NOAACurDir']        = './'; // relative location of the NOAAMO.TXT, NOAAYR.TXT, NOAAPRMO.TXT, NOAAPRYR.TXT files
#
# --------------------------------------------------------------------------
# Weather Station sensors and options for dashboard
#
$SITE['conditionsMETAR'] = 'KSJC';  // set to nearby METAR for current conditions icon/text
#  comment out conditionsMETAR if no nearby METAR.. conditions icon/text will not be displayed
#
$SITE['overrideRain']   = true; // =true then rain rate will set rain words instead of METAR rain words
#                               // =false - no change to METAR rain words (station rain rate not used)
$SITE['DavisVP']	   = true;  // set to false if not a Davis VP weather station
$SITE['UV']		   = true;  // set to false if no UV sensor
$SITE['SOLAR']		   = true;  // set to false if no Solar sensor
#
##########################################################################
# end of configurable settings
#
// default settings needed for various pages when the weather software plugin is not installed.
// do NOT change these
$SITE['WXsoftware']     = 'WL';
$SITE['WXsoftwareURL']  = 'http://www.davisnet.com/support/weather/software_sftwr.asp';
$SITE['WXsoftwareLongName'] = 'WeatherLink';
$SITE['ajaxDashboard']  = 'ajax-dashboard.php';
$SITE['trendsPage']     = 'WL-trends-inc.php'; // WL-specific trends page
$SITE['showSnow']	= false;   // Snow not recorded by WL
$SITE['showSnowTemp'] 	= -60;	  // disabled feature