<?php
// Author: Ken True - webmaster-weather.org
// gen-WLtags.php 
// Purpose: read the tags.txt file from WL and generate the WLtags.htx file for use with
//          WL to substitute weather values for WL tags in WLtags.php
//
// Version 1.00 - 06-Jan-2011 - Initial release
// --------------------------------------------------------------------------
// allow viewing of generated source
$Version = 'gen-WLtags.php - V1.02 - 10-Feb-2011';
$WXsoftware = 'WL'; // do NOT change this
$defsFile = $WXsoftware . '-defs.php'; // do NOT change this .. name of definitions file

if (isset($_REQUEST["sce"]) and strtolower($_REQUEST["sce"]) == "view" ) {
//--self downloader --
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header("Pragma: public");
   header("Cache-Control: private");
   header("Cache-Control: no-cache, must-revalidate");
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header("Connection: close");
   
   readfile($filenameReal);
   exit;
}

$inFile = 'WLtags.txt';

if(!file_exists($inFile)) {
	print "<h3>Program: $Version</h3>\n";
	print "<h1>Error: file '$inFile' not found.</h1>\n";
	print "<p>Make sure '$inFile' is in this same directory.</p>";
	return;
}

$showComments = false;
if(isset($_REQUEST['comments'])) {
	$showComments = (strtolower($_REQUEST['comments']) == 'yes')?true:false;
}

$rawrecs = file($inFile);
header("Content-type: text/plain");
print_start();
foreach ($rawrecs as $rec) {
/*
input:
Parameters (Description)
WeatherLink Tag	Variable
<!--insideTemp-->	Inside Temperature
<!--hiInsideTemp-->	High Inside Temperature

output:
v xv001|^vxv001^|// Wind Direction:|:
v hi001|^vhi001^|// Wind Direction Daily Hi:|:

*/
  preg_match('|^<!--(\S+)-->\s+(.*)$|i',$rec,$matches);
  if(!isset($matches[1])) {continue;}
  $ourname = $matches[1];
  $descr = $matches[2];
  $varname = "<!--$ourname-->";
  $comment = '';
  if($showComments) {
	  $comment = '|// '.$descr;
  }
  print "$ourname|$varname$comment:|:\n";
	
	
}
print_end();

// end of mainline
function print_start() {
	global $Version,$WXsoftware,$defsFile;
print '<?php
/*
 File: WLtags.htx 

 Purpose: load WL variables into a $WX[] array for use with the Canada/World/USA template sets

 Instructions:  
 Save this page as WLtags.htx and place in your weatherlink\[stationname]\templates directory
 
 Use the WeatherLink, Setup, Internet Settings... panel select a new configuration entry and press Configure.

 On the Data Upload Profile (n), select Upload every 5 minutes.  Press Select Template Files and
 In the Weather Template Files screen, press Add and select the WLtags.htx file in the file dialog.
 Set the Extension of Converted ".htx" file to be php and press OK
 
 Press OK on the Data Upload Profile to close it.
 Press OK on the Internet Settings dialog to close it and save the settings.


 Author: Ken True - webmaster@saratoga-weather.org

';
print " (created by $Version)\n";

print '*/
// --------------------------------------------------------------------------

// allow viewing of generated source

if (isset($_REQUEST["sce"]) and strtolower($_REQUEST["sce"]) == "view" ) {
//--self downloader --
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header("Pragma: public");
   header("Cache-Control: private");
   header("Cache-Control: no-cache, must-revalidate");
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header("Connection: close");
   
   readfile($filenameReal);
   exit;
}
' . 
"\$WXsoftware = '$WXsoftware';  
\$defsFile = '$defsFile';  // filename with \$varnames = \$WX['$WXsoftware-varnames']; equivalents\n " .
'
$rawdatalines = <<<END_OF_RAW_DATA_LINES
';
}

function print_end() {
global $WXsoftware, $defsFile;	
print 'END_OF_RAW_DATA_LINES;

// end of generation script

// put data in  array
//
$WX = array();
global $WX;
$WXComment = array();
$data = explode(":|:",$rawdatalines);
$nscanned = 0;
foreach ($data as $v => $line) {
  list($vname,$vval,$vcomment) = explode("|",trim($line).\'|||\');
  if ($vname <> "") {
    $WX[$vname] = trim($vval);
    if($vcomment <> "") { $WXComment[$vname] = trim($vcomment); }
  }
  $nscanned++;
}
if(isset($_REQUEST[\'debug\'])) {
  print "<!-- loaded $nscanned $WXsoftware \$WX[] entries -->\n";
}

if (isset($_REQUEST["sce"]) and strtolower($_REQUEST["sce"]) == "dump" ) {

  print "<pre>\n";
  print "// \$WX[] array size = $nscanned entries.\n";
  foreach ($WX as $key => $val) {
	  $t =  "\$WX[\'$key\'] = \'$val\';";
	  if(isset($WXComment[$key])) {$t .=  " $WXComment[$key]"; }
	  print "$t\n";
  }
  print "</pre>\n";

}
if(file_exists("'.$defsFile.'")) { include_once("'.$defsFile.'"); }
?>';
}